# -*- coding: utf-8 -*-
"""
Created on Fri Dec  4 10:31:17 2020

@author: Studente
"""

#from rtrace import trace


class BinTree:
    def __init__(self, value, left=None, right=None):
        self.value = value
        self.left = left
        self.right = right
        
    def __repr__(self, lev=0):
        string = ("\t"*lev) + f'{self.value}'
        if self.left:
            string += "\n\t" + ("\t"*lev) + self.left.__repr__(lev+1)
        else:   
            string += "\n\t" + ("\t"*lev) + '\tNone'
        if self.right:
            string += "\n\t" + ("\t"*lev) + self.right.__repr__(lev+1)
        else:
            string += "\n\t" + ("\t"*lev) + '\tNone'
        return string
        

def find(tree, x):
    found = False
    if tree.value == x:
        return True
    elif tree.left:
        #return find(tree.left, x) or (tree.right and find(tree.right))
        found = find(tree.left, x)
    if not found:
        if tree.right:
            found = find(tree.right, x)
    return found

#@trace
def count_leaves(tree):
    if not tree.left and not tree.right:
        return 1
    counter = 0
    if tree.left:
        counter = count_leaves(tree.left)
    if tree.right:
        counter += count_leaves(tree.right)
    return counter


def count_negative(tree):
    negative = 0
    if tree.value < 0:
        negative += 1
    if tree.left:
        negative += count_negative(tree.left)
    if tree.right:
        negative += count_negative(tree.right)
    return negative


def count_nodes_level(tree, level):
    if level == 0:
        return 1
    counter = 0
    if tree.left:
        counter += count_nodes_level(tree.left, level-1)
    if tree.right:
        counter += count_nodes_level(tree.right, level-1)
    return counter


def max_path_leaf(tree, lev=0):
    if not tree.left and not tree.right:
        return lev
    max_lev = 0
    if tree.left:
        max_lev = max_path_leaf(tree.left, lev+1)
    if tree.right:
        return max(max_lev, max_path_leaf(tree.right, lev+1)) 
    return max_lev


def max_path_leaf_2(tree):
    if not tree.left and not tree.right:
        return 0
    height, height2 = 0, 0
    if tree.left:
        height = max_path_leaf(tree.left)
    if tree.right:
        height2 = max_path_leaf(tree.right)
    return max(height, height2) + 1
#    if height>height2:
#        return height+1
#    else:
#        return height2+1


def remove_node_value(tree, x):
    pass

def remove_leftmost_leaf(tree):
    pass

def add_value(tree, value):
    if not tree.left and not tree.right:
        tree.left=BinTree(value)
        return
    ml, mr = 0,0
    if tree.left:
        ml = min_path(tree.left)
    if tree.right:
        mr = min_path(tree.right)
    if ml and mr:
        if ml > mr:
            add_value(tree.right, value)
        else:
            add_value(tree.left, value)
    elif ml:
        add_value(tree.right, value)
    else:
        add_value(tree.left, value)
        

def min_path(tree):
    if not tree.left and not tree.right:
        return 0
    height, height2 = 0, 0
    if tree.left:
        height = min_path(tree.left)
    if tree.right:
        height2 = min_path(tree.right)
    return min(height, height2) + 1
    




root = BinTree(6)
n12 = BinTree(12)
root.left=n12
n11 = BinTree(11)
root.right=n11
root.left.left = BinTree(2, BinTree(-6), BinTree(-2))
root.left.right = BinTree(5)
root.right.left = BinTree(3, BinTree(0), BinTree(5))
root.right.right = BinTree(7, BinTree(-1))

## count_leaves(6) -> waiting for count_leaves(12) -> gets 3 -> stores 3 it in counter -> waiting for count_leaves(11)
## count_leaves(12)-> waiting for count_leaves(2) -> gets 2 and stores 2 in counter -> waiting for count_leaves(5) -> gets 1 and sums it up with counter -> counter = 3 -> returns 3
## count_leaves(2) -> waiting for count_leaves(-6) -> gets 1 and stores 1 in counter -> waiting for count_leaves(-2) -> gets 1 and sums it up with counter -> counter = 2 -> returns 2
##     count_leaves(-6) -> returns 1
##  count_leaves(-2) -> returns 1
## count_leaves(5) -> returns 1
###....
# return 6







