

import bintree

'''
    Es 12: 3 points
    A tree is called complete binary if all its internal nodes have exactly 2
    children and all the leaves are on the same level.
    Design the recursive function es12(k) (or that uses recursive function(s)
    or recursive method(s)) that:
    - takes as argument an integer k 
    - constructs a binary tree complete with height k consisting of nodes of type  
      Nodo defined in the attached library albero.py. Leaf identifiers,
      read from left to right are the 2^k-integers ranging from 1 to 2^k (note that
      a complete binary tree with height k always has 2^k leaves). The identifiers
      of the internal nodes are given by the sum of the identifiers of their two children. 
    - returns as a result the root of the built tree. 
    Example: 
    - es12(2)  creates and returns the tree on the left
    - es12(3) creates and returns the tree on the right


                    10                                  36               
             _______|______                      _______|______         
            |              |                    |              |        
            3              7                   10             26        
         ___|___        ___|__               ___|___        ___|__      
        |       |      |      |             |       |      |      |     
        1       2      3      4             3       7     11     15     
                                           _|_     _|_    _|_    _|_    
                                          |   |   |   |  |   |  |   |   
                                          1   2   3   4  5   6  7   8   
                                                                   
    '''


def es1(k):
    # enter your code here
    root, number = gen_tree(k, 1)
    return root
    
def gen_tree(k, n):
    if k == 0:
        return bintree.BinTree(n), n
    left_tree, last_number = gen_tree(k-1, n)
    right_tree, last_number = gen_tree(k-1, last_number+1)
    new_node = bintree.BinTree(left_tree.value+right_tree.value, left_tree, right_tree)
    return new_node, last_number
    
    
    
    
    
    

    
