# -*- coding: utf-8 -*-
import bintree
"""
    Let us define the function es66, which is recursive (or makes use of
    your recursive functions) that:
    - Receives as argument a BinaryTree (defined in the file tree.py)

    Calculates the "maximum width" of the tree, that is the difference between 
    the position of the node that is more to the right in the tree
    and the position of the leftmost node.
    To calculate the position of a node with respect to the root
    (which we assume is at position 0) just:
       - subtract 1 (one) every time you go down on a left subtree, and
       - add 1 (one) each time you descend on a right subtree.
    Example: if the tree is the one below on the left, the positions will
             be those in the tree on the right
             1           .            0         .
            / \          .           / \        .
           2   3         .         -1   1       .
          / \            .        /  \          .
        4    5           .      -2    0         .
       /    /            .      /    /          .
      6    7             .    -3    -1          .
       \    \            .      \    \          .
        8    9           .      -2    0         .
    The leftmost node (6) is at position -3
    while the rightmost one (3) is at position 1
    So the function returns the value 4=1-(-3)
    """
def evaluate_positions(tree, pos=0):
    positions = {pos}
    if not tree.left and not tree.right:
        return positions
    if tree.left:
        positions.update(evaluate_positions(tree.left, pos-1))
    if tree.right:
        positions.update(evaluate_positions(tree.right, pos+1))
    return positions

    
def es66(tree):
    positions = evaluate_positions(tree)    
    return max(positions) - min(positions)
    

    
